<p>Among the most common types of web application vulnerabilities are Cross-Site Scripting (XSS) vulnerabilities. XSS vulnerabilities take advantage of a flaw in user input sanitization to “write” JavaScript code to the page and execute it on the client side, leading to several types of attacks. There are stored and temporary XSS vulnerabilities. The difference is easy to point out, and as you may have assumed, the goal of the attacker to exploit stored XSS. In this section of the course, we are exploiting a real XSS vulnerability found in Open edX Studio at the time of authoring this course. Below are the steps to reproduce:</p>
<ol>Login with an account to Studio</ol>
<ol>Select a course and export it</ol>
<ol>Unarchive the course and create/open “info/updates.items.json”</ol>
<ol>Add the content as shown below</ol>
<ol>Archive the course again</ol>
<ol>Import the new course content</ol>
<ol>Navigate to the course updates (in Studio and/or LMS)</ol>
<ol>See the alert popping up</ol>
<p>
    <pre>
        <code>
            [
                {
                    "content": "Hello I'll get your password.<script>alert(1)</script>",
                    "date",;"July5,2024",
                    "id": 1,
                    "status": "visible"
                }
            ]
        </code>
    </pre>
</p>
<p>Of course, the malicious script is only for demo purposes, so it is really basic. However, it would be just a step further to pull in remote JavaScript code, and display the exact same login page we have for the studio authentication. Since we cannot hijack the session (as that's using HTTP only cookies, and we are on a different domain), our best chance to be a bad guy is collecting the login credentials. As many, as we can. This issue could escalate quickly. If JavaScript is deployed and stored on the learner's side in LMS, the attacker could do even more nasty things. So… we must be very careful.</p>
<p>Back to the safe side, what could we do in this case? There are several options we have, though basically we have to HTML encode and escape the input we are getting from course upload.</p>
<p>The demonstrated vulnerability could be used for authenticated privilege escalation, meaning a staff user (or even a learner if XSS can be played the other way around) could trick an admin user and get their credentials.</p>